package models

type GoodsType struct {
	ID             int64  `gorm:"column:id" json:"id"`
	TypeCode       string `gorm:"column:type_code" json:"type_code"`
	TypeName       string `gorm:"column:type_name" json:"type_name"`
	Remark         string `gorm:"column:remark" json:"remark"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime"`
	Creater        int64  `gorm:"column:creater" json:"creater"`
	Modifier       int64  `gorm:"column:modifier" json:"modifier"`
	OrgId          int64  `gorm:"column:org_id" json:"org_id"`
	Status         int64  `gorm:"column:status" json:"status"`
	Type           int64  `gorm:"column:type" json:"type"`
	Number         int64  `gorm:"column:number" json:"number"`
	OutStock       int64  `gorm:"column:out_stock" json:"out_stock" form:"out_stock"`
	StockAttribute int64  `gorm:"column:stock_attribute" json:"stock_attribute" form:"stock_attribute"`
	IsOpen         int64  `gorm:"column:is_open" json:"is_open" form:"is_open"`
}

func (GoodsType) TableName() string {
	return "xt_goods_type"
}

type GoodInfo struct {
	ID                     int64   `gorm:"column:id" json:"id" form:"id"`
	GoodCode               string  `gorm:"column:good_code" json:"good_code" form:"good_code"`
	SpecificationName      string  `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
	GoodTypeId             int64   `gorm:"column:good_type_id" json:"good_type_id" form:"good_type_id"`
	GoodUnit               int64   `gorm:"column:good_unit" json:"good_unit" form:"good_unit"`
	BuyPrice               float64 `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	SellPrice              float64 `gorm:"column:sell_price" json:"sell_price" form:"sell_price"`
	Remark                 string  `gorm:"column:remark" json:"remark" form:"remark"`
	Ctime                  int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                  int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Manufacturer           int64   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Dealer                 int64   `gorm:"column:dealer" json:"dealer" form:"dealer"`
	ExpiryDateWarnDayCount int64   `gorm:"column:expiry_date_warn_day_count" json:"expiry_date_warn_day_count" form:"expiry_date_warn_day_count"`
	StockWarnCount         int64   `gorm:"column:stock_warn_count" json:"stock_warn_count" form:"stock_warn_count"`
	IsReuse                int64   `gorm:"column:is_reuse" json:"is_reuse" form:"is_reuse"`
	Status                 int64   `gorm:"column:status" json:"status" form:"status"`
	FilmArea               string  `gorm:"column:film_area" json:"film_area" form:"film_area"`
	IsUse                  int64   `gorm:"column:is_use" json:"is_use" form:"is_use"`
	FilmMaterialQuality    string  `gorm:"column:film_material_quality" json:"film_material_quality" form:"film_material_quality"`
	OrgId                  int64   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Modifier               int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
	Creater                int64   `gorm:"column:creater" json:"creater" form:"creater"`
	GoodName               string  `gorm:"column:good_name" json:"good_name" form:"good_name"`
	Pinyin                 string  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                   string  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	GoodKind               int64   `gorm:"column:good_kind" json:"good_kind" form:"good_kind"`
	MedicalInsuranceLevel  int64   `gorm:"column:medical_insurance_level" json:"medical_insurance_level" form:"medical_insurance_level"`
	RetailPrice            float64 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	MedicalInsuranceNumber string  `gorm:"column:medical_insurance_number" json:"medical_insurance_number" form:"medical_insurance_number"`
	ProvincesCode          string  `gorm:"column:provinces_code" json:"provinces_code" form:"provinces_code"`

	IsSpecialDiseases           int64                   `gorm:"column:is_special_diseases" json:"is_special_diseases" form:"is_special_diseases"`
	IsRecord                    int64                   `gorm:"column:is_record" json:"is_record" form:"is_record"`
	StatisticsCategory          int64                   `gorm:"column:statistics_category" json:"statistics_category" form:"statistics_category"`
	GoodStatus                  string                  `gorm:"column:good_status" json:"good_status" form:"good_status"`
	DefaultCount                int64                   `gorm:"column:default_count" json:"default_count" form:"default_count"`
	Sign                        int64                   `gorm:"column:sign" json:"sign" form:"sign"`
	IsDefault                   int64                   `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsChargeUse                 int64                   `gorm:"column:is_charge_use" json:"is_charge_use" form:"is_charge_use"`
	IsChargePredict             int64                   `gorm:"column:is_charge_predict" json:"is_charge_predict" form:"is_charge_predict"`
	IsStatisticsWork            int64                   `gorm:"column:is_statistics_work" json:"is_statistics_work" form:"is_statistics_work"`
	Sort                        int64                   `gorm:"column:sort" json:"sort" form:"sort"`
	IsDoctorUse                 int64                   `gorm:"column:is_doctor_use" json:"is_doctor_use" form:"is_doctor_use"`
	Agent                       string                  `gorm:"column:agent" json:"agent" form:"agent"`
	GoodNumber                  string                  `gorm:"column:good_number" json:"good_number" form:"good_number"`
	GoodsType                   GoodsType               `gorm:"ForeignKey:ID;AssociationForeignKey:GoodTypeId" json:"type"`
	CommdityCode                string                  `gorm:"column:commdity_code" json:"commdity_code" form:"commdity_code"`
	SocialSecurityDirectoryCode string                  `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	ProductionType              string                  `gorm:"column:production_type" json:"production_type" form:"production_type"`
	SpecialMedical              string                  `gorm:"column:special_medical" json:"special_medical" form:"special_medical"`
	IsMark                      int64                   `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	MinNumber                   int64                   `gorm:"column:min_number" json:"min_number" form:"min_number"`
	PackingUnit                 string                  `gorm:"column:packing_unit" json:"packing_unit" form:"packing_unit"`
	PackingPrice                float64                 `gorm:"column:packing_price" json:"packing_price" form:"packing_price"`
	DefaultCountUnit            string                  `gorm:"column:default_count_unit" json:"default_count_unit" form:"default_count_unit"`
	MinUnit                     string                  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Total                       float64                 `gorm:"column:total" json:"total" form:"total"`
	StWarehousingInfo           []*StWarehousingInfo    `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"xt_warehouse_info"`
	CancelStockInfo             []*CancelStockInfo      `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"cancel_stock_info"`
	RegisterNumber              string                  `gorm:"column:register_number" json:"register_number" form:"register_number"`
	GoodSotckInfo               []*GoodSotckInfo        `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"good_stock_in"`
	IsUser                      int64                   `gorm:"column:is_user" json:"is_user" form:"is_user"`
	Number                      string                  `gorm:"column:number" json:"number" form:"number"`
	IsWarehouse                 int64                   `gorm:"column:is_warehouse" json:"is_warehouse" form:"is_warehouse"`
	SumCount                    int64                   `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	BatchRetaiPrice             float64                 `gorm:"column:batch_retai_price" json:"batch_retai_price" form:"batch_retai_price"`
	SumInCount                  int64                   `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	WarehousingInfoOne          []*StartWarehousingInfo `gorm:"json:"warehouse_info"` //期间增加

	WarehousingInfoStart []*StartWarehousingInfo `gorm:"json:"warehouse_info_start"`

	WarehousingInfoEnd []*StartWarehousingInfo `gorm:"json:"warehouse_info_end"`
	WarehousingInfo    []*WarehousingInfo      `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"warehouse_info"`
	WarehouseOutInfo   []*WarehouseOutInfo     `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"warehouse_out_info"`

	WarehouseOutInfoEnd   []*VmStockFlow
	WarehouseOutInfoStart []*VmStockFlow
	WarehouseInfoEnd      []*VmStockFlow //期末入库量

	StartFlowWarehouseInfo []*VmStockFlow //本期增加

	//期初结余
	StartFlowInfo    []*VmStockFlow
	StartOutFlowInfo []*VmStockFlow

	//期末结余
	EndFlowInfo    []*VmStockFlow
	EndFlowOutInfo []*VmStockFlow

	//期初退库
	StartCancelFlowInfo []*VmStockFlow
	//期末退库
	EndCancelFLowInfo []*VmStockFlow

	StartEndCancelFLowInfo []*VmStockFlow

	WareStartStockInventoryProfit []*VmStockFlow //期初盘盈
	WareStartStockInventoryLosses []*VmStockFlow //期初盘亏

	WareEndStockInventoryProfit []*VmStockFlow //期末盘盈
	WareEndStockInventoryLosses []*VmStockFlow //期末盘亏

	WareStartEndStockInventoryProfit []*VmStockFlow //期间盘盈
	WareStartEndStockInventoryLosses []*VmStockFlow //期间盘亏
	SumOutCount                      int64          `gorm:"column:sum_out_count" json:"sum_out_count" form:"sum_out_count"`
	SumCancelCount                   int64          `gorm:"column:sum_cancel_count" json:"sum_cancel_count" form:"sum_cancel_count"`
	TotalCount                       int64          `gorm:"column:total_count" json:"total_count" form:"total_count"`
}

func (GoodInfo) TableName() string {
	return "xt_good_information"
}

type GoodInfoSeven struct {
	ID       int64  `gorm:"column:id" json:"id" form:"id"`
	GoodName string `gorm:"column:good_name" json:"good_name" form:"good_name"`
}

func (GoodInfoSeven) TableName() string {
	return "xt_good_information"
}

type GoodsTypeOne struct {
	ID             int64                    `gorm:"column:id" json:"id"`
	TypeCode       string                   `gorm:"column:type_code" json:"type_code"`
	TypeName       string                   `gorm:"column:type_name" json:"type_name"`
	Remark         string                   `gorm:"column:remark" json:"remark"`
	Ctime          int64                    `gorm:"column:ctime" json:"ctime"`
	Mtime          int64                    `gorm:"column:mtime" json:"mtime"`
	Creater        int64                    `gorm:"column:creater" json:"creater"`
	Modifier       int64                    `gorm:"column:modifier" json:"modifier"`
	OrgId          int64                    `gorm:"column:org_id" json:"org_id"`
	Status         int64                    `gorm:"column:status" json:"status"`
	Type           int64                    `gorm:"column:type" json:"type"`
	Number         int64                    `gorm:"column:number" json:"number"`
	OutStock       int64                    `gorm:"column:out_stock" json:"out_stock" form:"out_stock"`
	StockAttribute int64                    `gorm:"column:stock_attribute" json:"stock_attribute" form:"stock_attribute"`
	GoodInfo       []*GoodInformationThirty `gorm:"ForeignKey:GoodTypeId;AssociationForeignKey:ID" json:"GoodInfo"`
}

func (GoodsTypeOne) TableName() string {
	return "xt_goods_type"
}

type XtCancelStockInfo struct {
	ID              int64    `gorm:"column:id" json:"id"`
	GoodId          int64    `gorm:"column:good_id" json:"good_id"`
	CancelStockId   int64    `gorm:"column:cancel_stock_id" json:"cancel_stock_id"`
	GoodTypeId      int64    `gorm:"column:good_type_id" json:"good_type_id"`
	Count           int64    `gorm:"column:count" json:"count"`
	Price           float64  `gorm:"column:price" json:"price"`
	Total           float64  `gorm:"column:total" json:"total"`
	ProductDate     int64    `gorm:"column:product_date" json:"product_date"`
	ExpiryDate      int64    `gorm:"column:expiry_date" json:"expiry_date"`
	Ctime           int64    `gorm:"column:ctime" json:"ctime"`
	Mtime           int64    `gorm:"column:mtime" json:"mtime"`
	Status          int64    `gorm:"column:status" json:"status"`
	OrgId           int64    `gorm:"column:org_id" json:"org_id"`
	OrderNumber     string   `gorm:"column:order_number" json:"order_number"`
	Type            int64    `gorm:"column:type" json:"type"`
	Dealer          string   `gorm:"column:dealer" json:"dealer"`
	Manufacturer    string   `gorm:"column:manufacturer" json:"manufacturer"`
	GoodInfo        GoodInfo `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"GoodInfo"`
	Number          string   `gorm:"column:number" json:"number" form:"number"`
	RegisterAccount string   `gorm:"column:register_account" json:"register_account" form:"register_account"`
	Remark          string   `gorm:"column:remark" json:"remark" form:"remark"`
	IsCheck         int64    `gorm:"column:is_check" json:"is_check" form:"is_check"`
}

func (XtCancelStockInfo) TableName() string {
	return "xt_cancel_stock_info"
}

type BloodGoodsType struct {
	ID             int64  `gorm:"column:id" json:"id"`
	TypeCode       string `gorm:"column:type_code" json:"type_code"`
	TypeName       string `gorm:"column:type_name" json:"type_name"`
	Remark         string `gorm:"column:remark" json:"remark"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime"`
	Creater        int64  `gorm:"column:creater" json:"creater"`
	Modifier       int64  `gorm:"column:modifier" json:"modifier"`
	OrgId          int64  `gorm:"column:org_id" json:"org_id"`
	Status         int64  `gorm:"column:status" json:"status"`
	Type           int64  `gorm:"column:type" json:"type"`
	Number         int64  `gorm:"column:number" json:"number"`
	OutStock       int64  `gorm:"column:out_stock" json:"out_stock" form:"out_stock"`
	StockAttribute int64  `gorm:"column:stock_attribute" json:"stock_attribute" form:"stock_attribute"`
	IsOpen         int64  `gorm:"column:is_open" json:"is_open" form:"is_open"`
}

func (BloodGoodsType) TableName() string {
	return "xt_goods_type"
}

type GoodInformationThirty struct {
	ID                          int64   `gorm:"column:id" json:"id" form:"id"`
	GoodCode                    string  `gorm:"column:good_code" json:"good_code" form:"good_code"`
	SpecificationName           string  `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
	GoodTypeId                  int64   `gorm:"column:good_type_id" json:"good_type_id" form:"good_type_id"`
	GoodUnit                    int64   `gorm:"column:good_unit" json:"good_unit" form:"good_unit"`
	BuyPrice                    float64 `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	SellPrice                   float64 `gorm:"column:sell_price" json:"sell_price" form:"sell_price"`
	Remark                      string  `gorm:"column:remark" json:"remark" form:"remark"`
	Ctime                       int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                       int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Manufacturer                int64   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Dealer                      int64   `gorm:"column:dealer" json:"dealer" form:"dealer"`
	ExpiryDateWarnDayCount      int64   `gorm:"column:expiry_date_warn_day_count" json:"expiry_date_warn_day_count" form:"expiry_date_warn_day_count"`
	StockWarnCount              int64   `gorm:"column:stock_warn_count" json:"stock_warn_count" form:"stock_warn_count"`
	IsReuse                     int64   `gorm:"column:is_reuse" json:"is_reuse" form:"is_reuse"`
	Status                      int64   `gorm:"column:status" json:"status" form:"status"`
	FilmArea                    string  `gorm:"column:film_area" json:"film_area" form:"film_area"`
	IsUse                       int64   `gorm:"column:is_use" json:"is_use" form:"is_use"`
	FilmMaterialQuality         string  `gorm:"column:film_material_quality" json:"film_material_quality" form:"film_material_quality"`
	OrgId                       int64   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Modifier                    int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
	Creater                     int64   `gorm:"column:creater" json:"creater" form:"creater"`
	GoodName                    string  `gorm:"column:good_name" json:"good_name" form:"good_name"`
	Pinyin                      string  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                        string  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	GoodKind                    int64   `gorm:"column:good_kind" json:"good_kind" form:"good_kind"`
	MedicalInsuranceLevel       int64   `gorm:"column:medical_insurance_level" json:"medical_insurance_level" form:"medical_insurance_level"`
	RetailPrice                 float64 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	MedicalInsuranceNumber      string  `gorm:"column:medical_insurance_number" json:"medical_insurance_number" form:"medical_insurance_number"`
	IsSpecialDiseases           int64   `gorm:"column:is_special_diseases" json:"is_special_diseases" form:"is_special_diseases"`
	IsRecord                    int64   `gorm:"column:is_record" json:"is_record" form:"is_record"`
	StatisticsCategory          int64   `gorm:"column:statistics_category" json:"statistics_category" form:"statistics_category"`
	GoodStatus                  string  `gorm:"column:good_status" json:"good_status" form:"good_status"`
	DefaultCount                int64   `gorm:"column:default_count" json:"default_count" form:"default_count"`
	IsDefault                   int64   `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsChargeUse                 int64   `gorm:"column:is_charge_use" json:"is_charge_use" form:"is_charge_use"`
	IsChargePredict             int64   `gorm:"column:is_charge_predict" json:"is_charge_predict" form:"is_charge_predict"`
	IsStatisticsWork            int64   `gorm:"column:is_statistics_work" json:"is_statistics_work" form:"is_statistics_work"`
	Sign                        int64   `gorm:"column:sign" json:"sign" form:"sign"`
	Sort                        int64   `gorm:"column:sort" json:"sort" form:"sort"`
	IsDoctorUse                 int64   `gorm:"column:is_doctor_use" json:"is_doctor_use" form:"is_doctor_use"`
	Agent                       string  `gorm:"column:agent" json:"agent" form:"agent"`
	GoodNumber                  string  `gorm:"column:good_number" json:"good_number" form:"good_number"`
	CommdityCode                string  `gorm:"column:commdity_code" json:"commdity_code" form:"commdity_code"`
	SocialSecurityDirectoryCode string  `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	ProductionType              string  `gorm:"column:production_type" json:"production_type" form:"production_type"`
	SpecialMedical              string  `gorm:"column:special_medical" json:"special_medical" form:"special_medical"`
	IsMark                      int64   `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	Total                       float64 `gorm:"column:total" json:"total" form:"total"`
	MinNumber                   int64   `gorm:"column:min_number" json:"min_number" form:"min_number"`
	PackingUnit                 string  `gorm:"column:packing_unit" json:"packing_unit" form:"packing_unit"`
	PackingPrice                float64 `gorm:"column:packing_price" json:"packing_price" form:"packing_price"`
	DefaultCountUnit            string  `gorm:"column:default_count_unit" json:"default_count_unit" form:"default_count_unit"`
	MinUnit                     string  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	RegisterNumber              string  `gorm:"column:register_number" json:"register_number" form:"register_number"`
	ProvincesCode               string  `gorm:"column:provinces_code" json:"provinces_code" form:"provinces_code"`
	IsUser                      int64   `gorm:"column:is_user" json:"is_user" form:"is_user"`
	Number                      string  `gorm:"column:number" json:"number" form:"number"`
	IsWarehouse                 string  `gorm:"column:is_warehouse" json:"is_warehouse" form:"is_warehouse"`
	BatchRetaiPrice             float64 `gorm:"column:batch_retai_price" json:"batch_retai_price" form:"batch_retai_price"`
	SumCount                    int64   `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	SumInCount                  int64   `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	TotalCount                  int64   `gorm:"column:total_count" json:"total_count" form:"total_count"`
	SumOutCount                 int64   `gorm:"column:sum_out_count" json:"sum_out_count" form:"sum_out_count"`
	SumCancelCount              int64   `gorm:"column:sum_cancel_count" json:"sum_cancel_count" form:"sum_cancel_count"`
}

func (GoodInformationThirty) TableName() string {
	return "xt_good_information"
}

type GoodInformationFourty struct {
	ID                int64  `gorm:"column:id" json:"id" form:"id"`
	SpecificationName string `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
	OrgId             int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	GoodName          string `gorm:"column:good_name" json:"good_name" form:"good_name"`
	Status            int64  `gorm:"column:status" json:"status"`
}

func (GoodInformationFourty) TableName() string {
	return "xt_good_information"
}
