package models

type XtGoodStockCount struct {
	ID               int64 `gorm:"column:id" json:"id" form:"id"`
	UserOrgId        int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	GoodId           int64 `gorm:"column:good_id" json:"good_id" form:"good_id"`
	StorehouseId     int64 `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	Status           int64 `gorm:"column:status" json:"status" form:"status"`
	Ctime            int64 `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64 `gorm:"column:mtime" json:"mtime" form:"mtime"`
	StockInCount     int64 `gorm:"column:stock_in_count" json:"stock_in_count" form:"stock_in_count"`
	StockOutCount    int64 `gorm:"column:stock_out_count" json:"stock_out_count" form:"stock_out_count"`
	StockCancelCount int64 `gorm:"column:stock_cancel_count" json:"stock_cancel_count" form:"stock_cancel_count"`
	FlushCount       int64 `gorm:"column:flush_count" json:"flush_count" form:"flush_count"`
	StockActOutCount int64 `gorm:"column:stock_act_out_count" json:"stock_act_out_count" form:"stock_act_out_count"`
}

func (XtGoodStockCount) TableName() string {
	return "xt_good_stock_count"
}

type XtGoodErrcode struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Errcode        string `gorm:"column:errcode" json:"errcode" form:"errcode"`
	GoodId         int64  `gorm:"column:good_id" json:"good_id" form:"good_id"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Count          int64  `gorm:"column:count" json:"count" form:"count"`
	StockCount     int64  `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	Creater        int64  `gorm:"column:creater" json:"creater" form:"creater"`
	BatchNumberId  int64  `gorm:"column:batch_number_id" json:"batch_number_id" form:"batch_number_id"`
	WarehouseOutId int64  `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Code           string `gorm:"column:code" json:"code" form:"code"`
}

func (XtGoodErrcode) TableName() string {
	return "xt_good_errcode"
}

type XtDrugStockCount struct {
	ID             int64 `gorm:"column:id" json:"id" form:"id"`
	UserOrgId      int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	StorehouseId   int64 `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SumInCount     int64 `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	SumOutCount    int64 `gorm:"column:sum_out_count" json:"sum_out_count" form:"sum_out_count"`
	SumCancelCount int64 `gorm:"column:sum_cancel_count" json:"sum_cancel_count" form:"sum_cancel_count"`
	DrugId         int64 `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Ctime          int64 `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64 `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status         int64 `gorm:"column:status" json:"status" form:"status"`
	FlushCount     int64 `gorm:"column:flush_count" json:"flush_count" form:"flush_count"`
	SumActOutCount int64 `gorm:"column:sum_act_out_count" json:"sum_act_out_count" form:"sum_act_out_count"`
}

func (XtDrugStockCount) TableName() string {
	return "xt_drug_stock_count"
}

type NewBaseDrug struct {
	ID                     int64   `gorm:"column:id" json:"id" form:"id"`
	DrugName               string  `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Pinyin                 string  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                   string  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	DrugAlias              string  `gorm:"column:drug_alias" json:"drug_alias" form:"drug_alias"`
	DrugAliasPinyin        string  `gorm:"column:drug_alias_pinyin" json:"drug_alias_pinyin" form:"drug_alias_pinyin"`
	DrugAliasWubi          string  `gorm:"column:drug_alias_wubi" json:"drug_alias_wubi" form:"drug_alias_wubi"`
	DrugCategory           int64   `gorm:"column:drug_category" json:"drug_category" form:"drug_category"`
	DrugSpec               string  `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugType               int64   `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	DrugStockLimit         string  `gorm:"column:drug_stock_limit" json:"drug_stock_limit" form:"drug_stock_limit"`
	DrugOriginPlace        string  `gorm:"column:drug_origin_place" json:"drug_origin_place" form:"drug_origin_place"`
	DrugDosageForm         int64   `gorm:"column:drug_dosage_form" json:"drug_dosage_form" form:"drug_dosage_form"`
	MedicalInsuranceLevel  int64   `gorm:"column:medical_insurance_level" json:"medical_insurance_level" form:"medical_insurance_level"`
	MaxUnit                string  `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber              int64   `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit                string  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose                   string  `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit               string  `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	UnitMatrixing          string  `gorm:"column:unit_matrixing" json:"unit_matrixing" form:"unit_matrixing"`
	RetailPrice            float64 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	MinPrice               float64 `gorm:"column:min_price" json:"min_price" form:"min_price"`
	LastPrice              float64 `gorm:"column:last_price" json:"last_price" form:"last_price"`
	DrugControl            int64   `gorm:"column:drug_control" json:"drug_control" form:"drug_control"`
	Number                 string  `gorm:"column:number" json:"number" form:"number"`
	DrugClassify           string  `gorm:"column:drug_classify" json:"drug_classify" form:"drug_classify"`
	DrugDose               float64 `gorm:"column:drug_dose" json:"drug_dose" form:"drug_dose"`
	DrugDoseUnit           int64   `gorm:"column:drug_dose_unit" json:"drug_dose_unit" form:"drug_dose_unit"`
	MedicalInsuranceNumber string  `gorm:"column:medical_insurance_number" json:"medical_insurance_number" form:"medical_insurance_number"`
	ProvincesCode          string  `gorm:"column:provinces_code" json:"provinces_code" form:"provinces_code"`

	Manufacturer                int64                  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	PharmacologyCategory        int64                  `gorm:"column:pharmacology_category" json:"pharmacology_category" form:"pharmacology_category"`
	StatisticsCategory          int64                  `gorm:"column:statistics_category" json:"statistics_category" form:"statistics_category"`
	Code                        string                 `gorm:"column:code" json:"code" form:"code"`
	IsSpecialDiseases           int64                  `gorm:"column:is_special_diseases" json:"is_special_diseases" form:"is_special_diseases"`
	IsRecord                    int64                  `gorm:"column:is_record" json:"is_record" form:"is_record"`
	Agent                       string                 `gorm:"column:agent" json:"agent" form:"agent"`
	DrugStatus                  string                 `gorm:"column:drug_status" json:"drug_status" form:"drug_status"`
	LimitRemark                 string                 `gorm:"column:limit_remark" json:"limit_remark" form:"limit_remark"`
	DeliveryWay                 string                 `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	ExecutionFrequency          string                 `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	SingleDose                  float64                `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	PrescribingNumber           float64                `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	Label                       int64                  `gorm:"column:label" json:"label" form:"label"`
	Sort                        int64                  `gorm:"column:sort" json:"sort" form:"sort"`
	IsUseDoctorAdvice           int64                  `gorm:"column:is_use_doctor_advice" json:"is_use_doctor_advice" form:"is_use_doctor_advice"`
	IsDefault                   int64                  `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsChargePredict             int64                  `gorm:"column:is_charge_predict" json:"is_charge_predict" form:"is_charge_predict"`
	IsStatisticsWork            int64                  `gorm:"column:is_statistics_work" json:"is_statistics_work" form:"is_statistics_work"`
	IsChargeUse                 int64                  `gorm:"column:is_charge_use" json:"is_charge_use" form:"is_charge_use"`
	Status                      int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                       int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                       int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	OrgId                       int64                  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	DrugCode                    string                 `gorm:"column:drug_code" json:"drug_code" form:"drug_code"`
	Dealer                      int64                  `gorm:"column:dealer" json:"dealer" form:"dealer"`
	PrescriptionMark            int64                  `gorm:"column:prescription_mark" json:"prescription_mark" form:"prescription_mark"`
	RecordDate                  int64                  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	DrugRemark                  string                 `gorm:"column:drug_remark" json:"drug_remark" form:"drug_remark"`
	SocialSecurityDirectoryCode string                 `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	DoseCode                    string                 `gorm:"column:dose_code" json:"dose_code" form:"dose_code"`
	IsMark                      int64                  `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	HospApprFlag                int64                  `gorm:"column:hosp_appr_flag" json:"hosp_appr_flag" form:"hosp_appr_flag"`
	LmtUsedFlag                 int64                  `gorm:"column:lmt_used_flag" json:"lmt_used_flag" form:"lmt_used_flag"`
	DrugDay                     string                 `gorm:"column:drug_day" json:"drug_day" form:"drug_day"`
	Total                       float64                `gorm:"column:total" json:"total" form:"total"`
	PrescribingNumberUnit       string                 `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit" form:"prescribing_number_unit"`
	DrugWarehouseInfo           []*VsDrugWarehouseInfo `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
	XtDrugStockCount            []*XtDrugStockCount    `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_stock_count"`
	DrugStockCount              []*XtDrugStockCount    `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_stock_info"`
	TotalCount                  int64                  `gorm:"column:total_count" json:"total_count" form:"total_count"`
	IsUser                      int64                  `gorm:"column:is_user" json:"is_user" form:"is_user"`
	BatchRetaiPrice             float64                `gorm:"column:batch_retai_price" json:"batch_retai_price" form:"batch_retai_price"`
	DrugStockLimitCount         int64                  `gorm:"column:drug_stock_limit_count" json:"drug_stock_limit_count" form:"drug_stock_limit_count"`
	SumCount                    int64                  `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	SumInCount                  int64                  `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	IsPharmacy                  int64                  `gorm:"column:is_pharmacy" json:"is_pharmacy" form:"is_pharmacy"`
}

func (NewBaseDrug) TableName() string {
	return "xt_base_drug"
}

type XtDialysisSetting struct {
	ID                         int64 `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                  int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                     int64 `gorm:"column:status" json:"status" form:"status"`
	DeviceNumber               int64 `gorm:"column:device_number" json:"device_number" form:"device_number"`
	DeviceType                 int64 `gorm:"column:device_type" json:"device_type" form:"device_type"`
	Name                       int64 `gorm:"column:name" json:"name" form:"name"`
	AdmissionNumber            int64 `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	DialysisNo                 int64 `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	WeightBefor                int64 `gorm:"column:weight_befor" json:"weight_befor" form:"weight_befor"`
	DryWeight                  int64 `gorm:"column:dry_weight" json:"dry_weight" form:"dry_weight"`
	BloodPressure              int64 `gorm:"column:blood_pressure" json:"blood_pressure" form:"blood_pressure"`
	UltrafiltrationVolume      int64 `gorm:"column:ultrafiltration_volume" json:"ultrafiltration_volume" form:"ultrafiltration_volume"`
	InternalFistula            int64 `gorm:"column:internal_fistula" json:"internal_fistula" form:"internal_fistula"`
	BloodFlowVolume            int64 `gorm:"column:blood_flow_volume" json:"blood_flow_volume" form:"blood_flow_volume"`
	Anticoagulant              int64 `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	SealingFluidDispose        int64 `gorm:"column:sealing_fluid_dispose" json:"sealing_fluid_dispose" form:"sealing_fluid_dispose"`
	ModeId                     int64 `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	DialysisTime               int64 `gorm:"column:dialysis_time" json:"dialysis_time" form:"dialysis_time"`
	DialysisDialyszers         int64 `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         int64 `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	Gaijiliang                 int64 `gorm:"column:gaijiliang" json:"gaijiliang" form:"gaijiliang"`
	Kalium                     int64 `gorm:"column:kalium" json:"kalium" form:"kalium"`
	DisplaceLiquiValue         int64 `gorm:"column:displace_liqui_value" json:"displace_liqui_value" form:"displace_liqui_value"`
	Bicarbonate                int64 `gorm:"column:bicarbonate" json:"bicarbonate" form:"bicarbonate"`
	Glucose                    int64 `gorm:"column:glucose" json:"glucose" form:"glucose"`
	Ctime                      int64 `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                      int64 `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Sodium                     int64 `gorm:"column:sodium" json:"sodium" form:"sodium"`
	Calcium                    int64 `gorm:"column:calcium" json:"calcium" form:"calcium"`
	BloodAccess                int64 `gorm:"column:blood_access" json:"blood_access" form:"blood_access"`
	DialyzerPerfusionApparatus int64 `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus" form:"dialyzer_perfusion_apparatus"`
	DisplaceLiquiPart          int64 `gorm:"column:displace_liqui_part" json:"displace_liqui_part" form:"displace_liqui_part"`
}

func (XtDialysisSetting) TableName() string {
	return "xt_dialysis_setting"
}

type VmStockFlowTwenty struct {
	ID                  int64           `gorm:"column:id" json:"id" form:"id"`
	WarehousingId       int64           `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	GoodId              int64           `gorm:"column:good_id" json:"good_id" form:"good_id"`
	Count               int64           `gorm:"column:count" json:"count" form:"count"`
	UserOrgId           int64           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId           int64           `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	SystemTime          int64           `gorm:"column:system_time" json:"system_time" form:"system_time"`
	ConsumableType      int64           `gorm:"column:consumable_type" json:"consumable_type" form:"consumable_type"`
	IsSys               int64           `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	Price               float64         `gorm:"column:price" json:"price" form:"price"`
	WarehousingDetailId int64           `gorm:"column:warehousing_detail_id" json:"warehousing_detail_id" form:"warehousing_detail_id"`
	BuyPrice            float64         `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	IsRead              int64           `gorm:"column:is_read" json:"is_read" form:"is_read"`
	OverCount           int64           `gorm:"column:over_count" json:"over_count" form:"over_count"`
	Ctime               int64           `gorm:"column:ctime" json:"ctime" form:"ctime"`
	WarehousingInfo     WarehousingInfo `gorm:"ForeignKey:ID;AssociationForeignKey:WarehousingId" json:"xt_warehouse_info"`
}

func (VmStockFlowTwenty) TableName() string {
	return "xt_stock_flow"
}

type GoodInfoTwenty struct {
	ID                     int64                   `gorm:"column:id" json:"id" form:"id"`
	SpecificationName      string                  `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
	GoodTypeId             int64                   `gorm:"column:good_type_id" json:"good_type_id" form:"good_type_id"`
	BuyPrice               float64                 `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	Manufacturer           int64                   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Status                 int64                   `gorm:"column:status" json:"status" form:"status"`
	OrgId                  int64                   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	GoodName               string                  `gorm:"column:good_name" json:"good_name" form:"good_name"`
	RetailPrice            float64                 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	Ctime                  int64                   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	PackingUnit            string                  `gorm:"column:packing_unit" json:"packing_unit" form:"packing_unit"`
	PackingPrice           float64                 `gorm:"column:packing_price" json:"packing_price" form:"packing_price"`
	StWarehousingInfo      []*StWarehousingInfo    `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"xt_warehouse_info"`
	WarehousingInfoOne     []*StartWarehousingInfo `gorm:"json:"warehouse_info"` //期间增加
	WarehousingInfoStart   []*StartWarehousingInfo `gorm:"json:"warehouse_info_start"`
	WarehousingInfoEnd     []*StartWarehousingInfo `gorm:"json:"warehouse_info_end"`
	WarehouseOutInfoEnd    []*VmStockFlowTwenty
	WarehouseOutInfoStart  []*VmStockFlowTwenty
	WarehouseInfoEnd       []*VmStockFlowTwenty //期末入库量
	StartFlowWarehouseInfo []*VmStockFlowTwenty //本期增加
	//期初结余
	StartFlowInfo    []*VmStockFlowTwenty
	StartOutFlowInfo []*VmStockFlowTwenty
	//期末结余
	EndFlowInfo    []*VmStockFlowTwenty
	EndFlowOutInfo []*VmStockFlowTwenty
	//期初退库
	StartCancelFlowInfo []*VmStockFlowTwenty
	//期末退库
	EndCancelFLowInfo []*VmStockFlowTwenty

	StartEndCancelFLowInfo []*VmStockFlowTwenty

	WareStartStockInventoryProfit []*VmStockFlowTwenty //期初盘盈
	WareStartStockInventoryLosses []*VmStockFlowTwenty //期初盘亏

	WareEndStockInventoryProfit []*VmStockFlowTwenty //期末盘盈
	WareEndStockInventoryLosses []*VmStockFlowTwenty //期末盘亏

	WareStartEndStockInventoryProfit []*VmStockFlowTwenty //期间盘盈
	WareStartEndStockInventoryLosses []*VmStockFlowTwenty //期间盘亏

	//期初结余
	GoodStartFlowInfo VmStockFlowTwenty
	//期末结余
	GoodEndFlowInfo VmStockFlowTwenty
}

func (GoodInfoTwenty) TableName() string {
	return "xt_good_information"
}

type CancelStockInfoTwenty struct {
	ID              int64   `gorm:"column:id" json:"id"`
	GoodId          int64   `gorm:"column:good_id" json:"good_id"`
	Count           int64   `gorm:"column:count" json:"count"`
	Price           float64 `gorm:"column:price" json:"price"`
	Ctime           int64   `gorm:"column:ctime" json:"ctime"`
	Mtime           int64   `gorm:"column:mtime" json:"mtime"`
	Status          int64   `gorm:"column:status" json:"status"`
	OrgId           int64   `gorm:"column:org_id" json:"org_id"`
	Number          string  `gorm:"column:number" json:"number" form:"number"`
	WarehouseInfoId int64   `gorm:"column:warehouse_info_id" json:"warehouse_info_id" form:"warehouse_info_id"`
	PatientId       int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	RecordDate      int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck         int64   `gorm:"column:is_check" json:"is_check" form:"is_check"`
}

func (CancelStockInfoTwenty) TableName() string {
	return "xt_cancel_stock_info"
}

type WarehouseOutInfoTwenty struct {
	ID               int64           `gorm:"column:id" json:"id"`
	WarehouseOutId   int64           `gorm:"column:warehouse_out_id" json:"warehouse_out_id"`
	WarehouseInfotId int64           `gorm:"column:warehouse_info_id" json:"warehouse_info_id"`
	GoodId           int64           `gorm:"column:good_id" json:"good_id"`
	Count            int64           `gorm:"column:count" json:"count"`
	Price            float64         `gorm:"column:price" json:"price"`
	TotalPrice       float64         `gorm:"column:total_price" json:"total_price"`
	Mtime            int64           `gorm:"column:mtime" json:"mtime"`
	Ctime            int64           `gorm:"column:ctime" json:"ctime"`
	Status           int64           `gorm:"column:status" json:"status"`
	OrgId            int64           `gorm:"column:org_id" json:"org_id"`
	IsSys            int64           `gorm:"column:is_sys" json:"is_sys"`
	SysRecordTime    int64           `gorm:"column:sys_record_time" json:"sys_record_time"`
	PatientId        int64           `gorm:"column:patient_id" json:"patient_id"`
	ConsumableType   int64           `gorm:"column:consumable_type" json:"consumable_type" form:"consumable_type"`
	ProjectId        int64           `gorm:"column:project_id" json:"project_id" form:"project_id"`
	StorehouseId     int64           `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	BuyPrice         float64         `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	StockCount       string          `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	IsCheck          int64           `gorm:"column:is_check" json:"is_check" form:"is_check"`
	WarehousingInfo  WarehousingInfo `gorm:"ForeignKey:ID;AssociationForeignKey:WarehouseInfotId" `
	OverCount        int64           `gorm:"column:over_count" json:"over_count" form:"over_count"`
}

func (WarehouseOutInfoTwenty) TableName() string {
	return "xt_warehouse_out_info"
}

type WarehousingInfoTwenty struct {
	ID               int64   `gorm:"column:id" json:"id"`
	WarehousingId    int64   `gorm:"column:warehousing_id" json:"warehousing_id"`
	GoodId           int64   `gorm:"column:good_id" json:"good_id"`
	WarehousingCount int64   `gorm:"column:warehousing_count" json:"warehousing_count"`
	Price            float64 `gorm:"column:price" json:"price"`
	TotalPrice       float64 `gorm:"column:total_price" json:"total_price"`
	Dealer           int64   `gorm:"column:dealer" json:"dealer"`
	Manufacturer     int64   `gorm:"column:manufacturer" json:"manufacturer"`
	Ctime            int64   `gorm:"column:ctime" json:"ctime"`
	Mtime            int64   `gorm:"column:mtime" json:"mtime"`
	Status           int64   `gorm:"column:status" json:"status"`
	OrgId            int64   `gorm:"column:org_id" json:"org_id"`
	StockCount       int64   `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	WarehouseInfoId  int64   `gorm:"column:warehouse_info_id" json:"warehouse_info_id" form:"warehouse_info_id"`
	PackingPrice     float64 `gorm:"column:packing_price" json:"packing_price" form:"packing_price"`
	StorehouseId     int64   `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	IsCheck          int64   `gorm:"column:is_check" json:"is_check" form:"is_check"`
}

func (WarehousingInfoTwenty) TableName() string {
	return "xt_warehouse_info"
}

type VmBaseDrugTwenty struct {
	ID                               int64             `gorm:"column:id" json:"id" form:"id"`
	DrugType                         int64             `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	DrugName                         string            `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	MaxUnit                          string            `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber                        int64             `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit                          string            `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose                             string            `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit                         string            `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	RetailPrice                      float64           `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	MinPrice                         float64           `gorm:"column:min_price" json:"min_price" form:"min_price"`
	LastPrice                        float64           `gorm:"column:last_price" json:"last_price" form:"last_price"`
	Manufacturer                     int64             `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Status                           int64             `gorm:"column:status" json:"status" form:"status"`
	Ctime                            int64             `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                            int64             `gorm:"column:mtime" json:"mtime" form:"mtime"`
	OrgId                            int64             `gorm:"column:org_id" json:"org_id" form:"org_id"`
	DrugFlowWarehouseInfo            []*DrugFlowTwenty `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_flow_info"`
	DrugActFlowWarehouseInfo         []*DrugFlowTwenty `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_act_flow_info"`
	DrugWarehouseInfoStart           []*DrugFlowTwenty //期初入库结余
	DrugWarehouseOutInfoStart        []*DrugFlowTwenty //期初出库结余
	DrugWarehouseOutInfoEnd          []*DrugFlowTwenty //期末出库结余
	DrugWarehouseInfoEnd             []*DrugFlowTwenty //期末入库结余
	DrugWarehouseInfoStartEnd        []*DrugFlowTwenty //期中增加
	DrugWarehouseOutInfoStartEnd     []*DrugFlowTwenty //  期中减少
	WareStartStockInventoryProfit    []*DrugFlowTwenty //期初盘盈
	WareStartStockInventoryLosses    []*DrugFlowTwenty //期初盘亏
	WareEndStockInventoryProfit      []*DrugFlowTwenty //期末盘盈
	WareEndStockInventoryLosses      []*DrugFlowTwenty //期末盘亏
	WareStartEndStockInventoryProfit []*DrugFlowTwenty //期间盘盈
	WareStartEndStockInventoryLosses []*DrugFlowTwenty //期间盘亏
	WareStartStockCancelInfo         []*DrugFlowTwenty //期初结余退库
	WareEndStockCancelInfo           []*DrugFlowTwenty //期末结余退库
	WareStartEndStockCancelInfo      []*DrugFlowTwenty //期中减少退库

	DrugStatFlow DrugFlowTwenty
	DrugEndFlow  DrugFlowTwenty
}

func (VmBaseDrugTwenty) TableName() string {
	return "xt_base_drug"
}

type DrugFlowTwenty struct {
	ID                     int64                  `gorm:"column:id" json:"id" form:"id"`
	WarehousingId          int64                  `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	DrugId                 int64                  `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Count                  int64                  `gorm:"column:count" json:"count" form:"count"`
	UserOrgId              int64                  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId              int64                  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	SystemTime             int64                  `gorm:"column:system_time" json:"system_time" form:"system_time"`
	ConsumableType         int64                  `gorm:"column:consumable_type" json:"consumable_type" form:"consumable_type"`
	Manufacturer           int64                  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Status                 int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                  int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                  int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Price                  float64                `gorm:"column:price" json:"price" form:"price"`
	WarehousingDetailId    int64                  `gorm:"column:warehousing_detail_id" json:"warehousing_detail_id" form:"warehousing_detail_id"`
	WarehouseOutDetailId   int64                  `gorm:"column:warehouse_out_detail_id" json:"warehouse_out_detail_id" form:"warehouse_out_detail_id"`
	CancelOutDetailId      int64                  `gorm:"column:cancel_out_detail_id" json:"cancel_out_detail_id" form:"cancel_out_detail_id"`
	MaxUnit                string                 `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit                string                 `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	StorehouseId           int64                  `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	DrugWarehouseInfoOne   DrugWarehouseInfo      `gorm:"ForeignKey:ID;AssociationForeignKey:WarehousingDetailId"json:"xt_drug_warehouse_info" `
	IsRead                 int64                  `gorm:"column:is_read" json:"is_read" form:"is_read"`
	IsCheck                int64                  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	OverCount              int64                  `gorm:"column:over_count" json:"over_count" form:"over_count"`
	XtDrugWarehouseOutInfo XtDrugWarehouseOutInfo `gorm:"ForeignKey:ID;AssociationForeignKey:WarehouseOutDetailId"json:"xt_drug_warehouse_out_info" `
}

func (DrugFlowTwenty) TableName() string {
	return "xt_drug_flow"
}
